/*
Copyright 2018 Ultimaker

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	gcp_v1alpha1 "github.com/Ultimaker/gcp-operator/pkg/apis/gcp/v1alpha1"
	versioned "github.com/Ultimaker/gcp-operator/pkg/client/clientset/versioned"
	internalinterfaces "github.com/Ultimaker/gcp-operator/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/Ultimaker/gcp-operator/pkg/client/listers/gcp/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// GCPCloudSQLInstanceInformer provides access to a shared informer and lister for
// GCPCloudSQLInstances.
type GCPCloudSQLInstanceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.GCPCloudSQLInstanceLister
}

type gCPCloudSQLInstanceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewGCPCloudSQLInstanceInformer constructs a new informer for GCPCloudSQLInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewGCPCloudSQLInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredGCPCloudSQLInstanceInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredGCPCloudSQLInstanceInformer constructs a new informer for GCPCloudSQLInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredGCPCloudSQLInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.GcpV1alpha1().GCPCloudSQLInstances(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.GcpV1alpha1().GCPCloudSQLInstances(namespace).Watch(options)
			},
		},
		&gcp_v1alpha1.GCPCloudSQLInstance{},
		resyncPeriod,
		indexers,
	)
}

func (f *gCPCloudSQLInstanceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredGCPCloudSQLInstanceInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *gCPCloudSQLInstanceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&gcp_v1alpha1.GCPCloudSQLInstance{}, f.defaultInformer)
}

func (f *gCPCloudSQLInstanceInformer) Lister() v1alpha1.GCPCloudSQLInstanceLister {
	return v1alpha1.NewGCPCloudSQLInstanceLister(f.Informer().GetIndexer())
}
